#include <iostream>
using namespace std;

// prototype definitions
int Hamming(unsigned long aa, unsigned long bb);
long tau(long nn);
int primorial(int nn);

bool test_0a() {
  if (Hamming(10,14) != 1)
    return false;
  if (Hamming(1,15) != 3)
    return false;

  // all tests passed
  return true;
}

bool test_0b() {
  if (tau(1)!=0)
    return false;
  if (tau(2)!=2)
    return false;
  if (tau(3)!=3)
    return false;
  if (tau(6)!=5)
    return false;
  if (tau(12)!=7)
    return false;

  // all tests passed
  return true;
}

bool test_0c() {
  if (primorial(3) != 6)
    return false;
  if (primorial(10) != 210)
    return false;
  if (primorial(20) != 99690)
    return false;
  if (primorial(50) != 91410)
    return false;

  // all tests passed
  return true;
}

int main() {
  bool t0a = test_0a();
  bool t0b = test_0b();
  bool t0c = test_0c();

  cout << "Testing problem 0a: " << (t0a ? "passed" : "failed") << endl;
  cout << "Testing problem 0b: " << (t0b ? "passed" : "failed") << endl;
  cout << "Testing problem 0c: " << (t0c ? "passed" : "failed") << endl;

  if (t0a && t0b && t0c) {
    // all tests passed
    exit(0);
  }
  else {
    // at least one test was failed
    exit (-1);
  }
}